<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL$
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Author(s): Zack Bartel <bartel@osuosl.org>                             |
// +------------------------------------------------------------------------+
// $Id: ObjectOptionDataList.php 3985 2005-12-18 22:53:35Z bartel $
require_once("$phphtmllib/widgets/data_list/DefaultGUIDataList.inc");
require_once(DAOEXT.'/workgroup.php');
require_once(HTCLASS.'/DB_DataObjectDataListSource.php');
require_once(HTCLASS.'/DB_DataObjectDataList.php');

class ObjectOptionDataList extends DB_DataObjectDataList
{

//{{{   vars

    var $_default_rows_per_page = 38;
    var $obj_type;
    var $obj_id;

//}}}
//{{{   constructor()
    function ObjectOptionDataList($type = 'workgroup', $oid = null)
    {
        parent::DB_DataObjectDataList($type);
        $this->obj_id = $oid;
        $this->obj_type = $type;

    }
//}}}
//{{{   get_data_source()

    /**
     *  This method sets up the data source for the data list to be displayed.
     *  In Maintain's case, this means creating DBDataObject Data Source objects.
     */
    function get_data_source()
    {
        //$o = new $this->object_type($this->id);
        $oo = DB_DataObject::Factory('object_option');
        //$oo->setType($this->object_type);
        //$oo->object_id = $this->object_id;        

        //$oo->joinAdd($o);
        $src = &new DB_DataObjectDataListSource($oo);
        $this->set_data_source($src);
        $this->_default_orderby = 'id';
    }

//}}}
//{{{   user_setup()

    /**
     *  This method sets up the table columns and various other attributes like
     *  which of those columns is sortable, searchable, etc...
     */
    function user_setup()
    {
        global $conf;
        
        $this->set_actionbar(true);
        $this->set_form_method(POST);

        //$this->add_action_column('checkbox', 'FIRST', 'id');
        //$this->set_checkboxvar('zrmaps');

        $this->set_save_vars(array('id'=>$_REQUEST['id']));

        $this->add_header_item(_("DHCP Option"), '20%');
        $this->add_header_item(_("Entered Value"), '20%');
        $this->add_header_item(_("Final Value"), '20%');
        $this->add_header_item(_("Scope"), '20%');
        $this->add_header_item(_("Action"), '20%');
        
        $this->_datasource->setup_db_options(array('object_id' => $this->obj_id, 'type' => $this->obj_type));
    }

//}}}
//{{{   build_column_item()

    /**
     *  This method takes care of how the data in the columns will appear.
     *
     *  @param  array   $row_data   the row in question
     *  @param  string  $col_name   the column in question
     *
     *  @return Object  $obj        the custom rendering of the data
     */
    function build_column_item($row_data, $col_name)
    {
        switch ($col_name) {
        
        case _('Scope'):
            $obj = $row_data['scope'];
            break;
        
        case _('DHCP Option'):
            $opt = new DHCPOption($row_data['dhcp_option']);
            $obj = $opt->name;
            break;
        
        case _('Entered Value'):
            $obj = $row_data['value'];
            break;
        
        case _('Final Value'):
            $obj = $row_data['value'];
            break;

        case _('Action'):
            $editlink = html_a(web_root()."option.php?action=edit&amp;object_type={$this->obj_type}&amp;id={$row_data['id']}", _('Edit'));
            $dellink = html_a(web_root()."option.php?action=delete&amp;id=".$row_data['id'], _("Delete"));
            $obj = container($editlink, "|", $dellink);
            break;
        default:
            $obj = DefaultGUIDataList::build_column_item($row_data, $col_name);
            
        }

        return $obj;
    }

//}}}
//{{{   actionbar_cell()

    /**
     *  This method is what sets the information display at the bottom of the table.
     *  
     *  @return Container   A span that has strings for displaying the page numbers
     */
    function actionbar_cell()
    {
        $container = container();
        $del_button = html_input('submit', 'action', _('Delete Zones'));
        $def_button = html_input('submit', 'action', _('Toggle State'));
        $container->add($del_button);

        return $container;
    }
//}}}


}

?>
