<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL$
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Author(s): Zack Bartel <bartel@osuosl.org>                             |
// |            Frederic Wenzel <fred@osuosl.org>                           |
// +------------------------------------------------------------------------+
// $Id: ObjectOptionEditForm.php 3964 2006-01-26 21:49:51Z bartel $

/**
 *  ObjectOptionEditForm.php - contains the {@link HelpEditForm} class
 *
 *  @author $Author$
 *  @package    htdocs
 *  @subpackage forms
 *  @filesource
 */

require_once(FORMDIR."/MaintainForm.php");

/**
 *  This class is used for creating ObjectOption Records
 *  
 *  @package    htdocs
 *  @subpackage forms
 */
class ObjectOptionEditForm extends ObjectOptionCreateForm
{

//{{{ form_init_data()
    function form_init_data()  
    {
        $opt = new Option($_REQUEST['id']);
        $formary = $this->remap($opt->toArray(), FORM);
        
        foreach ($formary as $var=>$val)
            $this->set_element_value($var, $val);
    
    }
//}}}
//{{{   form_action()

    /**
     *  This method is what processes the data after validation.  In this case
     *  it updates a ObjectOption record. Here we use the object_option id
     *  rather than the object_id and object_type.
     *
     *  @return Boolean     True if action was successful
     */
    function form_action()
    {
        global $user;
    
        $res = true;
        switch(strtolower($this->get_action())) {
        
        case _("submit"):
            /* Grab form data and turn it into DB_DO dudes */
            $vars = $this->remap($this->get_all_element_values(), DBDO);
            $opt = new Option($_REQUEST['id']);
            $opt->query("BEGIN");
            $opt->setFrom($vars);
            $opt->update(); 
            $opt->query("COMMIT");

            break;

        default:
            $this->add_error(_("ERROR"), _("Invalid form action"));
            break;
        
        }

        return $res;
    }

//}}}
//{{{   form_success()

    /**
     *  This method lets them know they were successful in creating the record
     *  and allows them to go back to the index or to the list.
     */
    function form_success()
    {
        /* get the Option so we know what type it is */
        /*$opt = DB_DataObject::Factory('object_option');
        $opt->id = $_REQUEST['id'];
        $opt->selectAdd();
        $opt->selectAdd('type');
        $opt->selectAdd('object_id');
        $opt->fetch();
        var_dump($opt);*/
        $opt = new Option($_REQUEST['id']);

        $div = html_div("hsuccess");
        $indlink = html_a("index.php", "[Return to Home]");
        //$link = html_a($opt->type.".php?action=edit&amp;id={$opt->object_id}", "[Return to {$opt->type}]");
        $link = html_a("option.php?action=show&amp;object_type={$opt->type}&amp;id={$opt->object_id}", "[Return to {$opt->type}]");
        $div->add(container("Option Record updated",html_br()));
        $div->add(container($indlink, $link));
        return $div; 
    }

//}}}
//{{{ form_backend_validation()
    /*  Validate form values. We are using $_REQUEST['id'] in the edit
     *  form rather than $_REQUEST['object_id'] and object_type.
     *
     *
     *  @return Boolean     True if data is valid
     */
    function form_backend_validation()
    {
        $result = true;
        $vals = $this->remap($this->get_all_element_values(), DBDO);
        $opt = new Option($_REQUEST['id']);
        $opt->setFrom($vals);
        $valid = $opt->validate();
        if ($valid !== true)    {
            $errors = $this->remap($valid, FORM);
            foreach ($errors as $var=>$val)
            {
                if ($val !== true)  {
                    $this->add_error($var, $val);
                    $result = false;
                }
            }
        }
        return $result;
    }
//}}}
//{{{   form_hidden()

    /**
     *  This method should be overloaded by the child class and is used to add the
     *  hidden form variables to the form.
     *
     *  @return FEHidden    A hidden form element
     */
    function form_hidden()
    {
        $id = new FEHidden("id", $_REQUEST['id']);
        $this->add_element($id);

        $action = new FEHidden("action", $_REQUEST['action']);
        $this->add_element($action);

        return container($this->element_form(_("action")), $this->element_form("id"));
    }
}

?>
