<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain2/branches/2.6/htdocs/option.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Authors: Zack Bartel  <bartel@osuosl.org>                              |
// +------------------------------------------------------------------------+
// $Id: option.php 4125 2006-02-08 23:38:45Z bartel $

/**
  * Handles the search requests' forms and datalists.
  *
  * @package    htdocs
  */

require_once("includes.php");
require_once(FORMDIR."/SearchForm.php");
require_once(HTCLASS."/datalist/SearchDataList.php");

error_reporting(E_ALL ^ E_NOTICE);

session_start();

setup_user_environment();

$title = html_span("title");

$skin = Skin::Factory($user->color_template);
$content = container($title);
//print("<pre>".print_r($_POST, true)."</pre>");
switch(strtolower($_REQUEST['action']))  {

/* The "Search" button was pressed, display results */
case 'search':
    $data = $_POST['data'];
    
    if (!is_array($data))
        $data = array();    

    foreach ($data as $mod=>$objs)  {
        if (!is_array($objs))
            continue;

        $fs = html_fieldset($mod);
        foreach ($objs as $obj=>$val)   {
            $dl = new SearchDataList(_($obj), $mod, $obj);
            $dl->user_setup();
            $fs->add(html_h2($obj), $dl);
        }
        $content->add($fs);
    }
break;

default:
    $title->add(_("Search"));
    $sf = new FormProcessor(new SearchForm, "searchform");
    //$sf->set_render_form_after_success(false);
    $content->add($title, html_br(), $sf);
break;
}

print $skin->display($content);

?>
